import pygame, sys, os

sys.path.insert(0, './machines/')
sys.path.insert(0, './widgets/')
sys.path.insert(0, './utilities/')

from math import *
from random import *
from pygame.locals import *
import time

from render_man import Render_Man
from config import Config

from mode import Mode

cfg = Config().cfg

pygame.init()

clock = pygame.time.Clock()

os.environ['SDL_VIDEO_WINDOW_POS'] = 'center'
pygame.display.set_caption(cfg['globals']['default_title'])

# Build screen arguments.
scr_flags = 0
if cfg['globals']['fullscreen']:
    scr_flags |= FULLSCREEN
else:
    scr_flags |= 0
screen = pygame.display.set_mode(cfg['globals']['resolution'], scr_flags, 32)

running = True

rm = Render_Man(screen)
if cfg['globals']['current_mode'] not in cfg['globals']['machines']:
    print cfg['globals']['current_mode'], "doesn't exist."
    cfg['globals']['current_mode'] = 'lobby'
    

alt_ctrl = False
lmb_drag = False
lmb_pos = [0,0]

fps = cfg['globals']['frame_rate']

current_mode = None

def handle_events():
    global running
    global current_mode
    
    global alt_ctrl
    global lmb_drag
    global lmb_pos

    
    """Get mouse pos and ask if it's hovering anything"""
    m_pos = pygame.mouse.get_pos()

    current_mode.current_view.widget_update(m_pos)
    
    current_mode.current_view.on_hover(m_pos)

    """Main event loop"""
    mods = pygame.key.get_mods()
    if mods & pygame.KMOD_LALT and mods & pygame.KMOD_LCTRL: #Drag stuff
        alt_ctrl = True
        for event in pygame.event.get():
            if event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    lmb_drag = True
                    lmb_pos = m_pos
            elif event.type == pygame.MOUSEBUTTONUP:
                if event.button == 1:
                    lmb_drag = False
                    
            elif event.type == pygame.KEYDOWN:
                w = current_mode.current_view.current_widget
                if event.key == pygame.K_p:
                    print m_pos
                elif event.key == pygame.K_LEFTBRACKET:
                    print w.pos, w.name
                elif event.key and w:
                    if event.key == pygame.K_u:
                        w.pos[1] -= 1
                    elif event.key == pygame.K_j:
                        w.pos[1] += 1
                    elif event.key == pygame.K_h:
                        w.pos[0] -= 1
                    elif event.key == pygame.K_k:
                        w.pos[0] += 1
                    
        if lmb_drag == True:
            current_mode.current_view.widget_update(lmb_pos) #This stops the cursor escaping the widget.
            current_mode.current_view.on_drag(m_pos, lmb_pos)
            lmb_pos = m_pos
            
    else:
        alt_ctrl = False
        lmb_drag = False #turn drag off if the mod keys are lt go
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                running = False
    
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    running = False
                else:
                    current_mode.handle_key(event.key)
                    
            elif event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1: #LMB
                    current_mode.current_view.on_click(m_pos)
                elif event.button == 2: #Middle
                    pass
                elif event.button == 3: #RMB
                    pass
                elif event.button == 4: #Wheel up
                    current_mode.current_view.on_scroll_up(m_pos)
                elif event.button == 5: #Wheel down
                    current_mode.current_view.on_scroll_down(m_pos) 

def switch_mode(m_req):
    global current_mode
    if m_req in cfg["modes"]:
        if current_mode:
            del(current_mode.current_view) #DESTROY old mode
            del(current_mode.views)
            del(current_mode)
        current_mode = Mode(m_req, cfg) #Create new mode with the name token
    else:
        print "Trying to switch to a mode which does not exist!"

def quit_prog():
    global current_mode
    del current_mode.current_view
    del current_mode.views
    del current_mode
    time.sleep(1)
    pygame.display.quit()
    pygame.quit()
    sys.exit()

def main():
    switch_mode(cfg["globals"]["current_mode"])
    global running
    while(running == True):
        handle_events()
        
        m_req = current_mode.update() #Update and store returned value
        if m_req != None and m_req != "exit":
            switch_mode(m_req) #Switch mode based on returned value.
        elif m_req == "exit":
            running = False

        if alt_ctrl:
            current_mode.current_view.dirty = True

        rect_ls = current_mode.current_view.on_render(rm, alt_ctrl)


        pygame.display.update(rect_ls)
        clock.tick(fps)

    quit_prog()
    
main()
